/*********************************************************************
 *
 * File:         test.c
 *
 * Description:  Test application for NPAC Conferencing System  
 *
 * Author:       Tomasz Stachowiak, NPAC
 *
 * Date:         10-14-96
 *
 *********************************************************************/
#include <stdio.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/time.h>
#include <bstring.h>

#include <netdb.h>
#include <unistd.h>

#include <signal.h>

#include "../lib/common.h"

const char *user1 = "stach";
const char *host1 = "zavijah.npac.syr.edu";
const char *user2 = "stach";
const char *host2 = "tagore.npac.syr.edu";

int sockfd;
Participant part;
int state;

      
void Quit()
{
  ncsSessionQuit();
  exit(0);
}

void invited(void *data)
{
  printf("I am INVITED by %s@%s \n", ((Participant *)data)->user,((Participant *)data)->host );
  ncsSessionAcceptInvitation((Participant *)data);
}


void DisplayMenu()
{
  printf("MENU\n\n");
  printf("1 - Create session\n");
  printf("2 - Add member\n");
  printf("3 - Display members\n");
  printf("4 - Quit\n");
}

int ProcessInput(char *buf, int mystate)
{
  switch(buf[0])
    {
    case '1':
      ncsSessionCreate();
      break;

    case '2':
      scanf("%s", part.host);
      scanf("%s", part.user);
      printf("User: %s@%s\n", part.user, part.host);
      ncsSessionAddMember(&part);
      break;

    case '3':
      ncsSessionQueryMembers();
      break;

    case '4':
      Quit();
      break;

    default:
      printf("Unknown command\n");
    }

  DisplayMenu();
  return 1;
}
      

main(int argc, char *argv[])
{
  char buf[100];
  struct timeval timeout;
  fd_set set;

  ncsSessionInitialize();
  ncsSessionAddCallback(indLocalSessionInvited, invited);

  DisplayMenu();

  timeout.tv_sec = 1;
  timeout.tv_usec = 0;
  while(1)
    {
      sockfd = ncsSessionGetFD(&set);
      FD_SET(0, &set);
      if(select(sockfd+1, &set, 0, 0, &timeout) > 0)
	if(FD_ISSET(0, &set))
	  {
	    if(fgets(buf, 100, stdin) != NULL)
	      ProcessInput(buf, state);
	  }
      ncsProcessIncoming(&set);
    }
}



